Package com.io7m.waxmill.machines

# Class WXMDeviceSlot.Builder

java.lang.Object
com.io7m.waxmill.machines.WXMDeviceSlot.Builder

Enclosing class:
  WXMDeviceSlot

    public static final class WXMDeviceSlot.Builder
    extends java.lang.Object

Builds instances of type `WXMDeviceSlot`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `WXMDeviceSlot` | `build()` | Builds a new `WXMDeviceSlot`.
  `WXMDeviceSlot.Builder` | `from​(WXMDeviceSlotType instance)` | Fill a builder with attribute values from the provided `WXMDeviceSlotType` instance.
  `WXMDeviceSlot.Builder` | `setBusID​(int busID)` | Initializes the value for the `busID` attribute.
  `WXMDeviceSlot.Builder` | `setFunctionID​(int functionID)` | Initializes the value for the `functionID` attribute.
  `WXMDeviceSlot.Builder` | `setSlotID​(int slotID)` | Initializes the value for the `slotID` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final WXMDeviceSlot.Builder from​(WXMDeviceSlotType instance)
    Fill a builder with attribute values from the provided `WXMDeviceSlotType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setBusID

    public final WXMDeviceSlot.Builder setBusID​(int busID)
    Initializes the value for the `busID` attribute.
    Parameters:
      `busID` - The value for busID
    Returns:
      `this` builder for use in a chained invocation

  - ### setSlotID

    public final WXMDeviceSlot.Builder setSlotID​(int slotID)
    Initializes the value for the `slotID` attribute.
    Parameters:
      `slotID` - The value for slotID
    Returns:
      `this` builder for use in a chained invocation

  - ### setFunctionID

    public final WXMDeviceSlot.Builder setFunctionID​(int functionID)
    Initializes the value for the `functionID` attribute.
    Parameters:
      `functionID` - The value for functionID
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public WXMDeviceSlot build()
    Builds a new `WXMDeviceSlot`.
    Returns:
      An immutable instance of WXMDeviceSlot
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing